/****************************************************************************\
*   _SYS_DEP - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   biewlib/sysdep/_sys_dep.h                          *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain all development system depended part of BIEW project.   *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __SYS_DEP_H
#define __SYS_DEP_H

#ifdef __TSC__
   #include "biewlib/sysdep/ia16/__config.h"
   #include "biewlib/sysdep/ia16/_inlines.h"
#else
  #if defined(__WIN32__) && defined(_MSC_VER)
    #include "biewlib/sysdep/ia32/__config.h"
    #include "biewlib/sysdep/ia32/_inlines.h"
  #else
    #define _INLINES <biewlib/sysdep/##__MACHINE__/_inlines.h>
    #define __CONFIG <biewlib/sysdep/##__MACHINE__/__config.h>
    #include __CONFIG
    #include _INLINES
  #endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef max
#define max(a,b)    (((a) > (b)) ? (a) : (b))
#endif
#ifndef min
#define min(a,b)    (((a) < (b)) ? (a) : (b))
#endif

extern void __FASTCALL__ memupr(char *,unsigned);
extern void __FASTCALL__ memlwr(char *,unsigned);
#if defined(__GLIBC__) || defined (__UNIX__)
#define strupr(s) memupr(s,strlen(s))
#define strlwr(s) memlwr(s,strlen(s))
#define stricmp strcasecmp
#endif
#if (defined( __GNUC__ ) && !defined(__WIN32__)) || defined(__GLIBC__)
extern char *        ltoa(long _value, char *_s, int _radix);
#endif
#ifdef __GNUC__
#define atoul atoi /* alias */
extern char *        ultoa(unsigned long _value, char *_s, int _radix);
#endif

#if __BYTE_ORDER == __LITTLE_ENDIAN
    #define BYTE_SWAP_L(longval)      ByteSwapL(longval)
    #define BYTE_SWAP_S(shortval)     ByteSwapS(shortval)
    #define BIG_BYTE_SWAP_L(longval)  (longval)
    #define BIG_BYTE_SWAP_S(shortval) (shortval)
#else
    #define BYTE_SWAP_L(longval)      (longval)
    #define BYTE_SWAP_S(shortval)     (shortval)
    #define BIG_BYTE_SWAP_L(longval)  ByteSwapL(longval)
    #define BIG_BYTE_SWAP_S(shortval) ByteSwapS(shortval)
#endif

#ifdef __cplusplus
}
#endif

#endif


