/****************************************************************************\
*   _INLINES - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   biewlib/sysdep/ia16/_inlines.h                     *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file includes 16-bit Intel architecture little inline functions.     *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __TSC__
#include "biewlib/sysdep/generic/_inlines.h"
#else
#ifndef ___INLINES_H
#define ___INLINES_H

#define __NEAR__  near
#define __FAR__   far
#define __HUGE__  huge
#define __INTERRUPT__ interrupt
#define __STATIC__ static

/* TopSpeed's calling conventions are already "fast".
   Hence, the definition is not required. */

#define __FASTCALL__
#define __NORETURN__
#define __CONSTFUNC__

#ifdef __clpusplus
extern "C" {
#endif

/*
   We needs for own version of function hmemcpy because of some 16-bits
   compilers like TopSpeed have last argument as unsigned instead long.
*/
extern void __HUGE__ * __FASTCALL__ HMemCpy(void __HUGE__ *_dest, const void __HUGE__ *_source, unsigned long n);

#pragma save, call(inline=>on,reg_param=>(ax,bx),reg_return=>(ax,bx))
static unsigned short __FASTCALL__ ByteSwapS(unsigned short val) =
{
    0x86, 0xC4  /* xchg al, ah */
};

static unsigned long __FASTCALL__ ByteSwapL(unsigned long  val) =
{
    0x86, 0xC7,  /* xchg al, bh */
    0x86, 0xDC   /* xchg bl, ah */
};
#pragma restore

#define __Xlat__(t,i) (t[i])

#ifdef __cplusplus
}
#endif

#endif
#endif



