/****************************************************************************\
*   _INLINES - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   biewlib/sysdep/ia32/_inlines.h                     *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file includes 32-bit Intel architecture little inline functions.     *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#if !defined(__GNUC__) || !defined(__GNUC_MINOR__) || (__GNUC__ < 2 && __GNUC_MINOR__ < 5) || !defined(NDEBUG)
#include "biewlib/sysdep/generic/_inlines.h"
#else
#ifndef ___INLINES_H
#define ___INLINES_H

#define __NEAR__
#define __FAR__
#define __HUGE__
#define __INTERRUPT__
#define halloc malloc
#define hrealloc realloc
#define hfree free
#define HMemCpy memcpy

#ifdef __EXPERIMENTAL_VERSION
#define __FASTCALL__ __attribute__ (( __regparm__(3) , __stdcall__ ))
#else
#define __FASTCALL__
#endif
#define __NORETURN__ __attribute__ (( __noreturn__ ))
#define __CONSTFUNC__ __attribute__ (( __const__ ))
#ifdef __clpusplus
extern "C" {
#endif

__inline static unsigned short __FASTCALL__ __CONSTFUNC__ ByteSwapS(unsigned short _val)
{
  __asm("xchgb %b0,%h0"	:
        "=q" (_val)	:
        "0" (_val));
    return _val;
}

__inline static unsigned long __FASTCALL__ __CONSTFUNC__ ByteSwapL(unsigned long _val)
{
#if __CPU__ > 386
 __asm("bswap	%0"	:
      "=r" (_val)       :
#else
 __asm("xchgb	%b0,%h0\n"
      "	rorl	$16,%0\n"
      "	xchgb	%b0,%h0":
      "=q" (_val)	:
#endif
      "0" (_val));
  return _val;
}

#ifndef __BEOS__
__inline static unsigned char __FASTCALL__ __CONSTFUNC__ __Xlat__(const unsigned char *_table,unsigned char _idx)
{
 __asm("xlatb"   :
      "=a" (_idx):
      "0"(_idx),
      "b"(_table));
  return _idx;
}
#else
/* BEOS can not to process EBX in assembler statements */
#define __Xlat__(t,i) (t[i])
#endif

#ifdef __cplusplus
}
#endif

#endif
#endif
