/****************************************************************************\
*   TEXTMODE - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/mod/textmode.h                             *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain prototypes for textmode plugins.                        *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __TEXTMODE_H
#define __TEXTMODE_H

#ifndef __FILE_INI_RUNTIME_SUPPORT_SYSTEM__
#include "biewlib/file_ini.h"
#endif

typedef struct tag_REGISTRY_NLS
{
  const char *   set_name;
  unsigned       __FASTCALL__ (*convert_buffer)(char *buffer,unsigned len);
  unsigned       __FASTCALL__ (*get_symbol_size)( void );
  tBool          __FASTCALL__ (*select_table)( void );
  void           __FASTCALL__ (*read_ini)(hIniProfile *);
  void           __FASTCALL__ (*save_ini)(hIniProfile *);
  void           __FASTCALL__ (*init)( void );
  void           __FASTCALL__ (*term)( void );
}REGISTRY_NLS;

/* Below describes function prototypes for small table conversations */
extern void __FASTCALL__ txt_cvt_full(char * str,int size,const unsigned char *tmpl);
extern void __FASTCALL__ txt_cvt_hi80(char * str,unsigned size,const unsigned char *tmpl);
extern void __FASTCALL__ txt_cvt_lo80(char * str,unsigned size,const unsigned char *tmpl);



#endif


